<template>
  <div class="home">
    <b-row align-h="between">
        <b-col cols="2">
            <b-button v-b-toggle.sidebar-1 size="sm" variant="outline-secondary">
                <mdicon class="color-icon" name="menu" size="36" />
            </b-button>
        </b-col>
        <!--<b-col cols="auto">
            <b-icon class="rounded-circle p-2 bg-dark" variant="light" icon="bicycle" style="font-size: 45px;"></b-icon>
        </b-col>-->
        <b-col cols="8">
        <div v-if="isConnected == 'true'" class="mx-auto text-center">



         <!--   <b-button variant="outline mx-2" style="text-align:center">
              <div style="font-size: 12px;">Livraison - Maintenant</div>
              <div style="font-size: 14px;"><b>Chez moi</b></div>
            </b-button> -->

            <b-button @click="deconnexion" variant="outline mx-2" style="text-align:center">
              <div style="font-size: 14px;"><b>{{ $store.state.user.user.first_name }} {{ $store.state.user.user.last_name }}</b></div>
              <div style="font-size: 14px;">Se déconnecter</div>
            </b-button>
          
          </div>
          <div v-else class="mx-auto text-center">

           
            <b-button @click="$router.push('login')" variant="outline mx-2" style="text-align:center">
              <div style="font-size: 12px;">Vous n'êtes pas connecté</div>
              <div style="font-size: 14px;"><b>Connectez-vous !</b></div>
            </b-button>
          </div>
          </b-col>
        <b-col cols="2">
          <div v-if="isConnected == 'true'">
                <b-button @click="onClickCart" v-b-toggle.cartbar size="sm" variant="outline-secondary">
                    <mdicon class="color-icon" name="cart" size="36" />
                </b-button>
          </div>
        </b-col>
    </b-row>
    
    <SideBar/>
    
    <CartBar/>

    <b-container>
    <b-row class="row x-2 mt-3 mb-4" >
      <b-col cols="10">
         <b-form class="">
            <b-icon class="search-icon mx-2 my-2" variant="dark" icon="search" style="font-size: 1.25em"></b-icon>
            <b-form-input
              id="search-input"
              type="text"
              placeholder="Search"
            >
            </b-form-input>
          </b-form>
      </b-col>

      <b-col cols="1">
        <b-icon class="search-icon my-2" variant="dark" icon="filter" style="font-size: 1.35em"></b-icon>
      </b-col>
    </b-row>
    </b-container>

    <CarouselHome/>
    <LatestRestaurantsComponent/>
    <RestaurantsListComponent/>
    <b-alert
      :show="dismissCountDown"
      fade
      variant="warning"
      @dismissed="dismissCountDown=0"
      @dismiss-count-down="countDownChanged"
      class="px-mx-5"
    >
      <b-row align-h="between" >
        <b-col cols="4">User registred</b-col>
        <b-col cols="4"><b-spinner class="ml-auto"></b-spinner></b-col>
      </b-row>
    </b-alert>    
    <b-alert
      :show="dismissCountDownCart"
      fade
      variant="warning"
      @dismissed="dismissCountDownCart=0"
      @dismiss-count-down="countDownChanged"
      class="px-mx-5"
    >
      <b-row align-h="between" >
        <b-col cols="4">Commande passée</b-col>
        <b-col cols="4"><b-spinner class="ml-auto"></b-spinner></b-col>
      </b-row>
    </b-alert>

  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import LatestRestaurantsComponent from '@/components/HomeComponents/LatestRestaurantsComponent.vue'; 
import RestaurantsListComponent from '@/components/HomeComponents/RestaurantsListComponent.vue'; 
import CarouselHome from '@/components/HomeComponents/CarouselHome.vue';
import { mapActions, mapGetters } from 'vuex';
import SideBar from '@/components/SideBars/SideBar.vue';
import CartBar from '@/components/SideBars/CartBar.vue';
import router from '@/router';


export default Vue.extend({
  name: 'HomeView',
  components: {
    LatestRestaurantsComponent,
    RestaurantsListComponent,
    CarouselHome,
    SideBar,
    CartBar
  },

  /*computed: {
    ...mapGetters(["user", "isConnected"]),
  },*/


  methods: {
    ...mapActions(["getCart", "updateUserAlert", "updateCartAlert"]),

    onClickCart(){
      this.getCart()
    },

    deconnexion(){
      localStorage.removeItem('user');
      localStorage.removeItem('isConnected');
      window.location.reload()
    },
    countDownChanged(dismissCountDown: number) {
      this.updateUserAlert(false);
      this.updateCartAlert(false);
    }
  },



  data() {
    return {
      dismissCountDownCart: 0,
      dismissSecs: 3,
      dismissCountDown: 0,
      showDismissibleAlert: false,
      form: {
        search: '',
      },
      isConnected: false,
      user: {}
    }
  },

  created() {
    if (this.$store.state.user.alertUser) {
      this.dismissCountDown = this.dismissSecs;
    }
    if (this.$store.state.cart.alertCart) {
      this.dismissCountDownCart = this.dismissSecs;
    }
  },

  mounted() {
    if (localStorage.isConnected) {
      this.isConnected = localStorage.isConnected;
    }
    if (localStorage.user) {
      this.user = JSON.parse(localStorage.user);
    }
  },
});
</script>


<style>

.color-icon{
    color: black;
}

.home{
  background-color: #fdfdfd;
}

#search-input{
 /* width: 70%;*/
  padding-left:2em;
  border-radius: 10px;
}

.search-icon{
  position: absolute;
}

</style>